SystemOrganization addCategory: #'Mercury-Prototype-DebuggingSeed'!

!Exception methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 1/10/2013 12:16'!
handlerProcess 

	^ handlerProcess! !

!Exception methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 1/10/2013 12:16'!
handlerProcess: aHandlerProcess

	handlerProcess := aHandlerProcess! !

!Debugger methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 4/24/2013 13:45'!
confirm: aString

	^ true! !

!Debugger methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 1/14/2013 12:54'!
contextStack 

	^ contextStack! !

!Debugger methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 4/24/2013 13:44'!
inform: aString! !

!Process methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 9/4/2013 14:28'!
cleanHandler 
	"Interpreter enableMetaBehaviorForRegistered."
	handler ifNotNil: [handler class removeInstance: handler].
	handler := nil.! !

!Process methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 1/10/2013 11:53'!
handler

	^ handler! !

!Process methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 1/10/2013 11:53'!
handler: aHandler

	handler := aHandler! !

!Process methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 1/2/2013 10:28'!
reflectionPolicy 

	^ reflectionPolicy ifNil: [^ IntercessionSecurityPolicy ]! !

!Process methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 1/2/2013 10:31'!
reflectionPolicy: aReflectionPolicy

	reflectionPolicy := aReflectionPolicy ! !

!Process methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 1/24/2013 14:41'!
unhandledException

	^ uException! !

!Process methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 1/24/2013 14:42'!
unhandledException: anException

	uException := anException ! !

Object subclass: #DebuggingSeed
	instanceVariableNames: ''
	classVariableNames: 'registeredRequestor'
	poolDictionaries: ''
	category: 'Mercury-Prototype-DebuggingSeed'!

!DebuggingSeed class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/24/2013 15:30'!
authenticate

	"authentication is automatically handled by the middleware in the prototype see: Seamless authentication manager"
	
	self loadDebuggingSupport.
	
	^ Smalltalk globals! !

!DebuggingSeed class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/25/2013 17:29'!
interruptedProcesses

	^ SyncedDebuggingHandler activeInstances collect: [:instance | instance process]! !

!DebuggingSeed class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/24/2013 15:22'!
loadDebuggingSupport

	(Smalltalk globals keys includes: #RunTimeDebuggingSupport) ifFalse: [

		Gofer it
			url: 'http://ss3.gemstone.com/ss/Mercury-Prototype' username: 'nickp' password: 'drift145';
			package: 'Mercury-Prototype-RunTimeDebuggingSupport';
			load.
			
	]! !

!DebuggingSeed class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/23/2013 17:20'!
newUnhandledExceptionFrom: aHandler

	self loadDebuggingSupport.

	registeredRequestor ifNotNil: [[registeredRequestor newRemoteException: aHandler exception] fork].! !

!DebuggingSeed class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/24/2013 15:28'!
pushNewExceptionsTo: aRequestor

	registeredRequestor := aRequestor ! !

!DebuggingSeed class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 12:14'!
run: aString

	self unloadDebuggingSupport.
	[Compiler evaluate: aString] fork.! !

!DebuggingSeed class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/25/2013 17:29'!
unhandledExceptions 

	^ SyncedDebuggingHandler activeInstances collect: [:instance | instance exception]! !

!DebuggingSeed class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/24/2013 14:32'!
unloadDebuggingSupport

	Gofer it
		package: 'Mercury-Prototype-RunTimeDebuggingSupport';
		unload.! !

!Object methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 1/9/2013 10:45'!
xxx___isRemoteEnvironmentId 

	^ false! !

!Object methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 1/29/2013 12:12'!
xxx___runTimeDebuggingSupport 

	^ (Smalltalk globals at: #RunTimeDebuggingSupport) ! !
